Attribute VB_Name = "AllMacros"
Option Explicit

Sub RemoveExcessiveEnters()
    Dim lineBreakSearchRegExp As String
    lineBreakSearchRegExp = GetLineBreakSearchRegExp()
    
    Selection.HomeKey Unit:=wdStory
    While FindNextText(lineBreakSearchRegExp, True) = True
        RemoveNextEnters
    Wend
    ClearFindAndReplaceParameters
End Sub

Private Sub RemoveNextEnters()
    Selection.MoveStart wdWord, 1
    If Selection.Range.Start <> Selection.Range.End Then Selection.Delete
End Sub

Private Function GetLineBreakSearchRegExp()
    On Error GoTo Err
    FindNextText "[^013]{2,}", True
    GetLineBreakSearchRegExp = "[^013]{2,}"
    Exit Function
    
Err:
    GetLineBreakSearchRegExp = "[^013]{2;}"
End Function

Private Function FindNextText(value As String, useWildcards As Boolean)
    Selection.Find.ClearFormatting
    Selection.Find.Replacement.ClearFormatting
    With Selection.Find
        .Text = value
        .Forward = True
        .Format = False
        .MatchCase = False
        .MatchWholeWord = False
        .MatchKashida = False
        .MatchDiacritics = False
        .MatchAlefHamza = False
        .MatchControl = False
        .MatchWildcards = useWildcards
        .MatchSoundsLike = False
        .MatchAllWordForms = False
        .Wrap = wdFindStop
    End With
    Selection.Find.Execute
    FindNextText = Selection.Find.Found
End Function

Private Sub ClearFindAndReplaceParameters()
    With Selection.Find
       .ClearFormatting
       .Replacement.ClearFormatting
       .Text = ""
       .Replacement.Text = ""
       .Forward = True
       .Wrap = wdFindStop
       .Format = False
       .MatchCase = False
       .MatchWholeWord = False
       .MatchWildcards = False
       .MatchSoundsLike = False
       .MatchAllWordForms = False
    End With
End Sub

